/**
 * @file
 *
 * Macro @ref LIBSEX_DECLARE.
 */

#ifndef LIBSEX_DECLARE_HXX
#define LIBSEX_DECLARE_HXX

#include <source/Exception.hxx>

/// Macro for declaring exception classes (.hxx).
#define LIBSEX_DECLARE(parent, name) \
class name : public parent\
{\
public:\
	static const char* const TEMPLATE;\
	name(const char* const errorMessage);\
	name(\
		const char* const errorMessage,\
		const libsex::Exception& previous);\
};

#endif
