/**
 * @file
 *
 * Macro @ref LIBSEX_DEFINE.
 */

#ifndef LIBSEX_DEFINE_HXX
#define LIBSEX_DEFINE_HXX

/// Macro for defining exception classes (.cxx).
#define LIBSEX_DEFINE(parent, name, message) \
const char* const name::TEMPLATE = message;\
\
name::name(const char* const errorMessage)\
: parent(errorMessage)\
{\
}\
\
name::name(\
	const char* const errorMessage,\
	const libsex::Exception& previous)\
: parent(errorMessage, previous)\
{\
}\

#endif
